/*
 * http_post: A small library for POST data retrieval from CGI.
 * (c) 2007 Avelino Herrera Morales
 * M.H.P. Sistemas de Control S.L.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef  __HTTP_POST__H__
#define  __HTTP_POST__H__

extern char upload_path_prefix[256];

#define  WHAT_UNDEFINED  0
#define  WHAT_VALUE      1
#define  WHAT_FILE       2

typedef struct {
    char name[80];
    int what;
    union {
        char value[80];
        char filename[80];
        struct {
            unsigned char *ptr;   /* the uploaded data are stored here if "upload_path_prefix" is "" */
            int size;
        } buffer;
    } un;
} post_data;

void get_post_data(post_data **ret, int *numvars);
post_data *search_post_data(post_data *root, int numvars, char *name);

#endif  /* __HTTP_POST__H__ */
